_player = Turbine.Gameplay.LocalPlayer.GetInstance();
_imageDir="GambitHelper2/Resources/"
_iconDir="GambitHelper2/Resources/icons/"

_gambitList={							
{	"HOT",	6,	"21"	,"Persevere",			"persevere.tga"			},
{	"HOT",	9,	"23"	,"Impressive Flourish",		"impressive_flourish.tga"	},
{	"HOT",	24,	"212"	,"Safeguard",			"safeguard.tga"			},
{	"HOT",	40,	"2121"	,"Celebration of Skill",	"celebration_of_skill.tga"	},
{	"HOT",	54,	"23232"	,"Conviction",			"conviction.tga"		},
{	"HOT",	74,	"21212"	,"Restoration",			"restoration.tga"		},

{	"TOT",	12,	"31"	,"Precise Blow",		"precise_blow.tga"		},
{	"TOT",	13,	"32"	,"War Cry",			"war_cry.tga"			},

{	"TT",	16,	"232"	,"Maddening Strike",		"maddening_strike.tga"		},
{	"TT",	42,	"2323"	,"Dance Of War",		"dance_of_war.tga"		},
{	"TT",	50,	"231"	,"Deflection",			"deflection.tga"		},
{	"TT",	54,	"23232"	,"Conviction",			"conviction.tga"		},
{	"TT",	62,	"3213"	,"Aggression",			"aggression.tga"		},

{	"TI",	4,	"33"	,"Goad",			"goad.tga"			},
{	"TI",	30,	"313"	,"Piercing Strike",		"piercing_strike.tga"		},
{	"TI",	46,	"3131"	,"Spear of Virtue",		"spear_of_virtue.tga"		},
{	"TI",	48,	"3232"	,"Surety of Death",		"surety_of_death.tga"		},

{	"AVOID",2,	"22"	,"Defensive Strike",		"defensive_strike.tga"		},
{	"AVOID",20,	"213"	,"Shield Up",			"shield_up.tga"			},
{	"AVOID",34,	"2132"	,"Shield Mastery",		"shield_mastery.tga"		},
{	"AVOID",36,	"1212"	,"Wall of Steel",		"wall_of_steel.tga"		},
{	"AVOID",42,	"2323"	,"Dance Of War",		"dance_of_war.tga"		},
{	"AVOID",58,	"1321"	,"Adroit Manoeuvre",		"adroit_manoeuvre.tga"		},
{	"AVOID",68,	"2312"	,"Shield Tactics",		"shield_tactics.tga"		},
{	"AVOID",70,	"13213"	,"Warden's Triumph",		"wardens_triumph.tga"		},

{	"DOT",	1,	"11"	,"Deft Strike",			"deft_strike.tga"		},
{	"DOT",	3,	"12"	,"The Boot",			"the_boot.tga"			},
{	"DOT",	10,	"13"	,"Offensive Strike",		"offensive_strike.tga"		},
{	"DOT",	18,	"123"	,"Power Attack",		"power_attack.tga"		},
{	"DOT",	22,	"323"	,"Brink of Victory",		"brink_of_victory.tga"		},
{	"DOT",	28,	"131"	,"Combination Strike",		"combination_strike.tga"	},
{	"DOT",	32,	"121"	,"Onslaught",			"onslaught.tga"			},
{	"DOT",	36,	"1212"	,"Wall of Steel",		"wall_of_steel.tga"		},
{	"DOT",	38,	"1231"	,"Mighty Blow",			"mighty_blow.tga"		},
{	"DOT",	44,	"1313"	,"Boar's Rush",			"boars_rush.tga"		},
{	"DOT",	46,	"3131"	,"Spear of Virtue",		"spear_of_virtue.tga"		},
{	"DOT",	48,	"3232"	,"Surety of Death",		"surety_of_death.tga"		},
{	"DOT",	50,	"12312"	,"Unerring Strike",		"unerring_strike.tga"		},
{	"DOT",	52,	"132"	,"Reversal",			"reversal.tga"			},
{	"DOT",	56,	"32323"	,"Desolation",			"desolation.tga"		},
{	"DOT",	58,	"1321"	,"Adroit Manoeuvre",		"adroit_manoeuvre.tga"		},
{	"DOT",	64,	"12131"	,"The Dark Before Dawn",	"the_dark_before_dawn.tga"	},
{	"DOT",	70,	"13213"	,"Warden's Triumph",		"wardens_triumph.tga"		},

{	"MD",	26,	"312"	,"Fierce Resolve",		"fierce_resolve.tga"		},
{	"MD",	56,	"32323"	,"Desolation",			"desolation.tga"		},
{	"MD",	60,	"31232"	,"Exultation of Battle",	"exultation_of_battle.tga"	},
{	"MD",	72,	"3123"	,"Resolution",			"resolution.tga"		}
}

function SelectNone()
	_ghData.selected = {}
	for i,j in pairs(_gambitList) do
		_ghData.selected[j[4]] = false
	end
end

function FilterGambitList()

	if (_ghData.showall) then
		_levelFilter = 75
	else
		_levelFilter = _player:GetLevel();
	end

	_filteredGambitList={HOT={},TOT={},TT={},TI={},AVOID={}, DOT={},MD={}}
	local _winHeight=0
	local _winHeight2=0
	for i,j in ipairs(_gambitList) do
		if _levelFilter>=j[2] then
			if j[1]=="HOT" then
				table.insert (_filteredGambitList.HOT,{j[3],j[5],j[4]})
				_winHeight = _winHeight + 1
			end
			if j[1]=="TOT" then
				table.insert (_filteredGambitList.TOT,{j[3],j[5],j[4]})
				_winHeight = _winHeight + 1
			end
			if j[1]=="TT" then
				table.insert (_filteredGambitList.TT,{j[3],j[5],j[4]})
				_winHeight = _winHeight + 1
			end
			if j[1]=="TI" then
				table.insert (_filteredGambitList.TI,{j[3],j[5],j[4]})
				_winHeight = _winHeight + 1
			end
			if j[1]=="AVOID" then
				table.insert (_filteredGambitList.AVOID,{j[3],j[5],j[4]})
				_winHeight = _winHeight + 1
			end
			if j[1]=="DOT" then
				table.insert (_filteredGambitList.DOT,{j[3],j[5],j[4]})
				_winHeight2 = _winHeight2 + 1
			end
			if j[1]=="MD" then
				table.insert (_filteredGambitList.MD,{j[3],j[5],j[4]})
				_winHeight2 = _winHeight2 + 1
			end
		end
	end
	
	local headcount1=0
	local headcount2=0
	if (tablelength(_filteredGambitList.HOT) >0) then headcount1=headcount1+1 end
	if (tablelength(_filteredGambitList.TOT) >0) then headcount1=headcount1+1 end
	if (tablelength(_filteredGambitList.TT) >0) then headcount1=headcount1+1 end
	if (tablelength(_filteredGambitList.TI) >0) then headcount1=headcount1+1 end
	if (tablelength(_filteredGambitList.AVOID) >0) then headcount1=headcount1+1 end
	if (tablelength(_filteredGambitList.DOT) >0) then headcount2=headcount2+1 end
	if (tablelength(_filteredGambitList.MD) >0) then headcount2=headcount2+1 end

	headersize1=headcount1*12
	headersize2=headcount2*12
			
	GambitWindow1:SetSize(198,614)
	GambitWindow2:SetSize(198,614)
	GList:SetSize(180,_winHeight*18+headersize1) -- resize window to fit all gambit available.
	iconList1:SetSize(18,_winHeight*18+headersize1)
	GList:SetPosition(18,614-(_winHeight*18)-headersize1-14)
	iconList1:SetPosition(0,614-(_winHeight*18)-headersize1-14)
	
	moraleBar:SetPosition(18,600);
	
	GList2:SetSize(180,_winHeight2*18+headersize2) -- resize window to fit all gambit available.
	iconList2:SetSize(18,_winHeight2*18+headersize2)
	GList2:SetPosition(18,614-(_winHeight2*18)-headersize2-14)
	iconList2:SetPosition(0,614-(_winHeight2*18)-headersize2-14)
	
	powerBar:SetPosition(18,600);
	
	-- refresh dragbars
	GambitWindow1.DragBar:Refresh()
	GambitWindow2.DragBar:Refresh()
end