Settings = class( Turbine.UI.Window );

function Settings:Constructor()
	Turbine.UI.Lotro.Window.Constructor( self );
	
	self:SetPosition(_ghData.sx, _ghData.sy);
	self:SetSize(400, 250);
	self:SetText("Gambit Helper Options");
		
	-- general settings
	_labelGeneral = Turbine.UI.Label()
    _labelGeneral:SetParent(self)
    _labelGeneral:SetPosition(30, 30)
    _labelGeneral:SetSize(340, 20)
	_labelGeneral:SetFont(Turbine.UI.Lotro.Font.TrajanPro14)
	_labelGeneral:SetForeColor(_fontColorHeader)
    _labelGeneral:SetText("-- MISC OPTIONS --")
	_labelGeneral:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter )
		
	-- ooc visibility
	_ooc = Turbine.UI.Lotro.CheckBox()
	_ooc:SetParent(self)
	_ooc:SetSize(380, 20)
	_ooc:SetPosition(10, 60)
	_ooc:SetFont(Turbine.UI.Lotro.Font.Verdana12)
	_ooc:SetForeColor(_fontColor)
	_ooc:SetText(" Show gambit windows out of combat.")
	_ooc:SetChecked(_ghData.ooc_visibility)
	_ooc.CheckedChanged = function( sender, args )
							ToggleOOC()
						 end

	-- showall
	_vitals = Turbine.UI.Lotro.CheckBox()
	_vitals:SetParent(self)
	_vitals:SetSize(380, 20)
	_vitals:SetPosition(10, 80)
	_vitals:SetFont(Turbine.UI.Lotro.Font.Verdana12)
	_vitals:SetForeColor(_fontColor)
	_vitals:SetText(" Show vitals")
	_vitals:SetChecked(_ghData.vitals)
	_vitals.CheckedChanged = function( sender, args )
							ToggleVitals()
						 end
						 
	-- showall
	_all = Turbine.UI.Lotro.CheckBox()
	_all:SetParent(self)
	_all:SetSize(380, 20)
	_all:SetPosition(10, 100)
	_all:SetFont(Turbine.UI.Lotro.Font.Verdana12)
	_all:SetForeColor(_fontColor)
	_all:SetText(" Show all gambits")
	_all:SetChecked(_ghData.showall)
	_all.CheckedChanged = function( sender, args )
							ToggleShowAll()
						 end
						 
	-- showall
	_icons = Turbine.UI.Lotro.CheckBox()
	_icons:SetParent(self)
	_icons:SetSize(380, 20)
	_icons:SetPosition(10, 120)
	_icons:SetFont(Turbine.UI.Lotro.Font.Verdana12)
	_icons:SetForeColor(_fontColor)
	_icons:SetText(" Show gambit icons")
	_icons:SetChecked(_ghData.icons)
	_icons.CheckedChanged = function( sender, args )
							ToggleIcons()
						 end					 
						 
	-- actions
	_labelActions = Turbine.UI.Label()
    _labelActions:SetParent(self)
    _labelActions:SetPosition(10, 160)
    _labelActions:SetSize(380, 20)
	_labelActions:SetFont(Turbine.UI.Lotro.Font.TrajanPro14)
	_labelActions:SetForeColor(_fontColorHeader)
    _labelActions:SetText("-- ACTIONS --")
    _labelActions:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter )

	-- reset positions
	_resetButton = Turbine.UI.Lotro.Button()
	_resetButton:SetParent(self)
	_resetButton:SetSize(100, 20)
	_resetButton:SetPosition(10, 190)
	_resetButton:SetFont(Turbine.UI.Lotro.Font.Verdana12)
	_resetButton:SetForeColor(_fontColor)
	_resetButton:SetText("Reset")
	_resetButton.Click= function (sender, args)
						Reset()
						end
						
	_labelResetButton = Turbine.UI.Label()
    _labelResetButton:SetParent(self)
    _labelResetButton:SetPosition(120, 194)
    _labelResetButton:SetSize(270, 20)
	_labelResetButton:SetFont(Turbine.UI.Lotro.Font.Verdana12)
	_labelResetButton:SetForeColor(_fontColor)
    _labelResetButton:SetText("Reset default window positions")
	
	-- rebuild
	_rebuildButton = Turbine.UI.Lotro.Button()
	_rebuildButton:SetParent(self)
	_rebuildButton:SetSize(100, 20)
	_rebuildButton:SetPosition(10, 210)
	_rebuildButton:SetFont(Turbine.UI.Lotro.Font.Verdana12)
	_rebuildButton:SetForeColor(_fontColor)
	_rebuildButton:SetText("Rebuild")
	_rebuildButton.Click= function (sender, args)
						Rebuild()
						end
						
	_labelRebuildButton = Turbine.UI.Label()
    _labelRebuildButton:SetParent(self)
    _labelRebuildButton:SetPosition(120, 214)
    _labelRebuildButton:SetSize(270, 20)
	_labelRebuildButton:SetFont(Turbine.UI.Lotro.Font.Verdana12)
	_labelRebuildButton:SetForeColor(_fontColor)
    _labelRebuildButton:SetText("Rebuild list of gambits (use after leveling)")
   	  
	-- save on exit
	self.Closed = function( sender, args )
		_ghData.sx,_ghData.sy=_ghSettings:GetPosition()
		if not (_ghSettings == nil) then _ghSettings = nil end
		--SaveSettings()
		-- uudet
				
		GambitWindow1:SetVisible (_ghData.ooc_visibility)
		GambitWindow2:SetVisible (_ghData.ooc_visibility)
		UpdateDisplay()
	end
end